from __future__ import annotations

from collections.abc import Mapping
from typing import Any, TypeVar

from attrs import define as _attrs_define
from attrs import field as _attrs_field

from ..types import UNSET, Unset

T = TypeVar("T", bound="TypesTrack")


@_attrs_define
class TypesTrack:
    """
    Attributes:
        field_id (str | Unset):
        campaign (str | Unset):
        click (bool | Unset):
        ip (str | Unset):
        source (str | Unset):
        tag (str | Unset):
        timestamp (str | Unset):
        url (str | Unset):
    """

    field_id: str | Unset = UNSET
    campaign: str | Unset = UNSET
    click: bool | Unset = UNSET
    ip: str | Unset = UNSET
    source: str | Unset = UNSET
    tag: str | Unset = UNSET
    timestamp: str | Unset = UNSET
    url: str | Unset = UNSET
    additional_properties: dict[str, Any] = _attrs_field(init=False, factory=dict)

    def to_dict(self) -> dict[str, Any]:
        field_id = self.field_id

        campaign = self.campaign

        click = self.click

        ip = self.ip

        source = self.source

        tag = self.tag

        timestamp = self.timestamp

        url = self.url

        field_dict: dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update({})
        if field_id is not UNSET:
            field_dict["_id"] = field_id
        if campaign is not UNSET:
            field_dict["campaign"] = campaign
        if click is not UNSET:
            field_dict["click"] = click
        if ip is not UNSET:
            field_dict["ip"] = ip
        if source is not UNSET:
            field_dict["source"] = source
        if tag is not UNSET:
            field_dict["tag"] = tag
        if timestamp is not UNSET:
            field_dict["timestamp"] = timestamp
        if url is not UNSET:
            field_dict["url"] = url

        return field_dict

    @classmethod
    def from_dict(cls: type[T], src_dict: Mapping[str, Any]) -> T:
        d = dict(src_dict)
        field_id = d.pop("_id", UNSET)

        campaign = d.pop("campaign", UNSET)

        click = d.pop("click", UNSET)

        ip = d.pop("ip", UNSET)

        source = d.pop("source", UNSET)

        tag = d.pop("tag", UNSET)

        timestamp = d.pop("timestamp", UNSET)

        url = d.pop("url", UNSET)

        types_track = cls(
            field_id=field_id,
            campaign=campaign,
            click=click,
            ip=ip,
            source=source,
            tag=tag,
            timestamp=timestamp,
            url=url,
        )

        types_track.additional_properties = d
        return types_track

    @property
    def additional_keys(self) -> list[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
